module Unified_MultiPort_RAM (
    input clock,
    input en,

    input we0,
    input [31:0] d0,
    output reg [31:0] q0,
    input [31:0] addr0,

    input we1,
    input [31:0] d1,
    output reg [31:0] q1,
    input [31:0] addr1,

    input we2,
    input [31:0] d2,
    output reg [31:0] q2,
    input [31:0] addr2,
    
    input we3,
    input [31:0] d3,
    output reg [31:0] q3,
    input [31:0] addr3
);

reg [31:0] mem [1023:0];

always @(posedge clock) begin
    if(en) begin
        if(we0 | we1 | we2 | we3) begin
            // if write_enable is asserted, push the data into the address
            if(we0)
                mem[addr0] = d0 ;
            if(we1)
                mem[addr1] = d1 ;
            if(we2)
                mem[addr2] = d2 ;
            if(we3)
                mem[addr3] = d3 ;
        end
    end
end

always @(posedge clock) begin
    if(en) begin
        // if write_enable is deasserted, pop the stored data to the port q
        q0 = mem[addr0] ;
        q1 = mem[addr1] ;
        q2 = mem[addr2] ;
        q3 = mem[addr3] ;
    end
end
    
endmodule