`timescale 1ns/1ns
`define T 2
`include "unified_multiport_ram.v"
module testbench();

reg clock, we0, we1, we2, we3, en;
reg [31:0] d0,d1,d2,d3;
wire [31:0] q0,q1,q2,q3;
reg [31:0] addr0,addr1,addr2,addr3;

initial begin
    $dumpfile("testbench.vcd");
    $dumpvars(0,testbench);
end

initial begin
    clock = 0;
    we0 = 0;
    we1 = 0;
    we2 = 0;
    we3 = 0;
    d0 = 32'h1111;
    d1 = 32'h2222;
    d2 = 32'h3333;
    d3 = 32'h4444;
end

always #1 clock = ~clock;

initial begin
    #2 en = 1;
    #2 
    we0 = 1;
    addr0 = 32'd1;
    #2
    we0 = 0;
    #2
    we1 = 1;
    addr1 = 32'd1;
    #2
    we1 = 0;
    #2
    we2 = 1;
    we3 = 1;
    addr2 = 32'd1;
    addr3 = 32'd1;
    #2
    we2 = 0;
    we3 = 0;
    #2 $stop;
end

Unified_MultiPort_RAM u0(
    .clock( clock ),
    .en( en ),

    .we0( we0 ),
    .d0( d0 ),
    .q0( q0 ),
    .addr0( addr0 ),

    .we1( we1 ),
    .d1( d1 ),
    .q1( q1 ),
    .addr1( addr1 ),

    .we2( we2 ),
    .d2( d2 ),
    .q2( q2 ),
    .addr2( addr2 ),
    
    .we3( we3 ),
    .d3( d3 ),
    .q3( q3 ),
    .addr3 (addr3)
);

endmodule
